// So I made it super easy for you to toggle between tone maps I've
// come up with by changing the "false" statement to "true" statement.
// one active tone map is ideal, since activating every tone map
// operator will process the color in sequence from first operator to
// to the final one.

bool GMap = false;
bool colorBias = true;
bool reCurve = false;
bool SmootherStep = false;
bool bezierCurve = false;

/*
int N = 9;

float bezier(float n, int k, vec2 p) {
		return nCr(N, k) * pow(1.0 - n, N - k) * pow(n, k) * dot(p.x, p.y);
}
*/

vec3 ToneMapping(vec3 x) {

	//Default to normal if all tonemap options are disabled.
	vec3 Final = x;

	if(GMap) {
		/*
		//First iteration, original.
		vec3 CI = x;
		vec3 CF = vec3(0.3, 0.2, 0.0);
		float colorP = max(dot(CF, CI), 0.5);
		float colorS = pow(dot(CF, 1.0), 1.0);
		CF = CF * vec3(colorP);
		CF = CF * vec3(colorS);
		CF = CI * CF;

		CI = CI * max(CF, CI);
		CI *= 2.0;

		Final = CI;
		*/
	}

		if(colorBias) {
			//Second iteration, replace the first one for unsupported device.
			float A = 0.6;
			float B = 0.4;
			float C = 0.8;
			float D = 0.65;
			float E = 0.9;
			float F = 1.2;

			vec3 film = vec3(0.4, 0.3, 0.0);
			vec3 colorize = vec3(0.4, 0.3, 0.0);

			float newFilm = dot(film, film * x);
			vec3 newColor = colorize * newFilm;

			x = x * (x + newColor);
			x = clamp(x, 0.0, 1.0);
			x *= 4.0;

			vec3 GengharFilmic = -((x * ((A + B) / (x + C)) + D) / (x * (A / B) + (A * E))) + F;

			Final = GengharFilmic;
		}

		if(reCurve) {
			/*
			//Third iteration, replace second one for better brightness control.
			vec3 ReCurve = log((((x * abs(x + 0.16) / (pow(2.0, x) / 4.8)) * ((x * pow(2.0, 1.0)) / (pow(4.0, x)))) / pow(0.16, x)) + 1.0);

			Final = ReCurve;
			*/
		}

		if(SmootherStep) {
			//Forth iteration, SmootherStep, smoother than SmoothStep.
			vec3 N = x;
			vec3 SmootherStep = N * N * N * (N * (N * vec3(6.0) - vec3(15.0)) + vec3(10.0));
			SmootherStep = clamp(SmootherStep, 0.0, 1.0);

			Final = SmootherStep;
		}

		if(bezierCurve) {
			/*
			vec2 p1 = vec2(0.3, 0.4);
			vec2 p2 = vec2(1.0);
			
			Final = vec3(bezier(length(x), 0, p1));*/
		}

		return Final;
}